"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.Primary = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _isNativeReflectConstruct2 = _interopRequireDefault(require("@babel/runtime/helpers/isNativeReflectConstruct"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireWildcard(require("react"));
var _uikit = require("@gravity-ui/uikit");
var _index = require("../../index");
var _SizeContext = require("../../../stories/SizeContext");
var _ConfirmedFormValues = require("../../../stories/ConfirmedFormValues");
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _callSuper(t, o, e) {
  return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, (0, _isNativeReflectConstruct2.default)() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e));
}
var DialogWithSelectStories = /*#__PURE__*/function (_Component) {
  function DialogWithSelectStories() {
    var _this;
    (0, _classCallCheck2.default)(this, DialogWithSelectStories);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, DialogWithSelectStories, [].concat(args));
    _this.state = {
      dialogVisible: true,
      initialState: {
        general: {
          firstName: 'John'
        }
      },
      formData: undefined,
      showModal: false
    };
    _this.onToggleModal = function () {
      _this.setState({
        showModal: !_this.state.showModal
      });
    };
    _this.onAdd = function (form) {
      _this.setState({
        formData: form.getState().values
      });
      return Promise.resolve();
    };
    return _this;
  }
  (0, _inherits2.default)(DialogWithSelectStories, _Component);
  return (0, _createClass2.default)(DialogWithSelectStories, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var verticalTabs = this.props.verticalTabs;
      var _this$state = this.state,
        initialState = _this$state.initialState,
        formData = _this$state.formData,
        showModal = _this$state.showModal;
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_react.Fragment, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Button, {
          onClick: this.onToggleModal,
          children: "Show modal"
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_ConfirmedFormValues.ConfirmedFormValues, {
          data: formData
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(DialogDemo, {
          initialValues: formData || initialState,
          onAdd: this.onAdd,
          modal: false,
          verticalTabs: verticalTabs
        }), showModal && /*#__PURE__*/(0, _jsxRuntime.jsx)(DialogDemo, {
          initialValues: formData,
          modal: true,
          onAdd: this.onAdd,
          onClose: function onClose() {
            return _this2.onToggleModal();
          },
          verticalTabs: verticalTabs
        })]
      });
    }
  }]);
}(_react.Component);
function DialogDemo(_ref) {
  var modal = _ref.modal,
    onAdd = _ref.onAdd,
    initialValues = _ref.initialValues,
    onClose = _ref.onClose,
    verticalTabs = _ref.verticalTabs;
  var tabType = verticalTabs ? 'tab-vertical' : 'tab';
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_index.DFDialog, (0, _objectSpread2.default)((0, _objectSpread2.default)({
    modal: modal,
    headerProps: {
      title: 'Form-level validation'
    }
  }, (0, _SizeContext.useSize)()), {}, {
    onClose: onClose !== null && onClose !== void 0 ? onClose : function () {},
    visible: true,
    onAdd: onAdd,
    initialValues: initialValues,
    pristineSubmittable: true,
    fields: [{
      name: 'general',
      title: 'General',
      type: tabType,
      fields: [{
        type: 'block',
        name: 'block',
        extras: {
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            style: {
              color: 'gray'
            },
            children: "In some cases it is more convinient to use form validator. Especially when values of fields depends to each other or when you are using virtualized tabs."
          })
        }
      }, {
        name: 'firstName',
        type: 'text',
        caption: 'First name'
      }, {
        name: 'lastName',
        type: 'text',
        caption: 'Last name'
      }]
    }],
    validate: function validate(_ref2) {
      var general = _ref2.general;
      var generalErrs = {};
      if (!general.firstName) {
        generalErrs.firstName = 'First name shold not be empty';
      }
      if (general.lastName && general.firstName === 'John' && general.lastName !== 'Snow') {
        generalErrs.lastName = '"Snow" is better for John';
      } else if (!(general !== null && general !== void 0 && general.lastName)) {
        generalErrs.lastName = 'Last name should not be empty (also try "John" as a first name)';
      }
      return {
        general: generalErrs
      };
    }
  }));
}
var _default = exports.default = {
  title: 'Demo/07. Form validation',
  component: DialogWithSelectStories
};
var Template = function Template(args) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(DialogWithSelectStories, (0, _objectSpread2.default)({}, args));
};
var Primary = exports.Primary = Template.bind({});
Primary.args = {};
// #sourceMappingURL=07_Form_validation.stories.js.map
// #sourceMappingURL=07_Form_validation.stories.js.map