"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.WithMaxVisibleCount = exports.WithItemRenderer = exports.Frozen = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _isNativeReflectConstruct2 = _interopRequireDefault(require("@babel/runtime/helpers/isNativeReflectConstruct"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireDefault(require("react"));
var _cn = require("../../../helpers/cn");
var _index = require("../index");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _callSuper(t, o, e) {
  return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, (0, _isNativeReflectConstruct2.default)() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e));
}
var b = (0, _cn.dfCN)('editable-lists-control-demo');
function genEditableListData() {
  return ['red', 'white', 'black', 'green', 'orange', 'magenta', 'cyan', 'lime', 'purple', 'red white black green orange magenta cyan lime purple 1', 'red white black green orange magenta cyan lime purple 2'].map(function (i, index) {
    return {
      title: i,
      frozen: index % 3 === 0
    };
  });
}
function genEditableManyListsData() {
  return [{
    title: 'To add',
    data: genEditableListData(),
    itemClassName: b('add')
  }, {
    title: 'Will be removed',
    data: genEditableListData(),
    itemClassName: b('remove')
  }];
}
var DemoItem = /*#__PURE__*/function (_React$Component) {
  function DemoItem() {
    var _this;
    (0, _classCallCheck2.default)(this, DemoItem);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, DemoItem, [].concat(args));
    _this.state = {
      data: genEditableManyListsData()
    };
    _this.onChange = function (data) {
      _this.setState({
        data: data
      });
    };
    return _this;
  }
  (0, _inherits2.default)(DemoItem, _React$Component);
  return (0, _createClass2.default)(DemoItem, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_react.default.Fragment, {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_index.EditableManyLists, (0, _objectSpread2.default)((0, _objectSpread2.default)({}, this.props), {}, {
          value: this.state.data,
          onChange: this.onChange
        })), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
          style: {
            padding: 40,
            whiteSpace: 'pre-wrap'
          },
          children: ['[', this.state.data.reduce(function (acc, item, index) {
            acc.push(/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
              style: {
                paddingLeft: 20
              },
              children: [JSON.stringify(item), ","]
            }, index));
            return acc;
          }, []), "]"]
        })]
      });
    }
  }]);
}(_react.default.Component);
var _default = exports.default = {
  title: 'Components/EditableManyList',
  component: DemoItem
};
var Template = function Template(args) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(DemoItem, (0, _objectSpread2.default)({}, args));
};
var Frozen = exports.Frozen = Template.bind({});
Frozen.args = {};
var WithMaxVisibleCount = exports.WithMaxVisibleCount = Template.bind({});
WithMaxVisibleCount.args = {};
var WithItemRenderer = exports.WithItemRenderer = Template.bind({});
WithItemRenderer.args = {
  itemRenderer: function itemRenderer(item) {
    var title = item.title,
      removed = item.removed;
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      style: {
        textDecoration: removed ? 'line-through' : 'underline'
      },
      children: title
    });
  }
};
// #sourceMappingURL=EditableManyLists.stories.js.map
// #sourceMappingURL=EditableManyLists.stories.js.map