"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LabelsGroup = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _isNativeReflectConstruct2 = _interopRequireDefault(require("@babel/runtime/helpers/isNativeReflectConstruct"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireWildcard(require("react"));
var _map = _interopRequireDefault(require("lodash/map"));
var _uikit = require("@gravity-ui/uikit");
var _cn = require("../../../helpers/cn");
var _withCollapsible = _interopRequireDefault(require("../../../hoc/withCollapsible"));
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _callSuper(t, o, e) {
  return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, (0, _isNativeReflectConstruct2.default)() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e));
}
var block = (0, _cn.dfCN)('labels-group');
var LabelsGroupComponent = /*#__PURE__*/function (_Component) {
  function LabelsGroupComponent() {
    var _this;
    (0, _classCallCheck2.default)(this, LabelsGroupComponent);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, LabelsGroupComponent, [].concat(args));
    _this.handleLabelClick = function (label) {
      var onClick = _this.props.onClick;
      if (typeof onClick === 'function') {
        onClick(label);
      }
    };
    _this.handleRemoveClick = function (evt, label) {
      var onRemove = _this.props.onRemove;
      evt.stopPropagation();
      if (typeof onRemove === 'function') {
        onRemove(label);
      }
    };
    return _this;
  }
  (0, _inherits2.default)(LabelsGroupComponent, _Component);
  return (0, _createClass2.default)(LabelsGroupComponent, [{
    key: "renderLabel",
    value: function renderLabel(label) {
      var _this2 = this;
      var _this$props = this.props,
        onRemove = _this$props.onRemove,
        disabled = _this$props.disabled;
      var name = label.name,
        isDefault = label.isDefault;
      var onLabelClick = function onLabelClick() {
        return _this2.handleLabelClick(label);
      };
      var onRemoveClick = function onRemoveClick(evt) {
        return _this2.handleRemoveClick(evt, label);
      };
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Label, {
        className: block('label'),
        type: onRemove && !isDefault ? 'close' : 'default',
        onClick: onLabelClick,
        onCloseClick: onRemoveClick,
        size: "s",
        disabled: disabled,
        children: name
      }, name);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        items = _this$props2.items,
        renderToggler = _this$props2.renderToggler,
        onRemoveAll = _this$props2.onRemoveAll,
        disabled = _this$props2.disabled;
      return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: block(),
        children: [(0, _map.default)(items, function (label) {
          return _this3.renderLabel(label);
        }), renderToggler === null || renderToggler === void 0 ? void 0 : renderToggler(), onRemoveAll && items.length > 0 && /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Button, {
          size: "s",
          view: "flat-secondary",
          onClick: onRemoveAll,
          disabled: disabled,
          children: "Clear all"
        })]
      });
    }
  }]);
}(_react.Component);
var LabelsGroup = exports.LabelsGroup = (0, _withCollapsible.default)(LabelsGroupComponent);
// #sourceMappingURL=LabelsGroup.js.map
// #sourceMappingURL=LabelsGroup.js.map