"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TabField = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _isNativeReflectConstruct2 = _interopRequireDefault(require("@babel/runtime/helpers/isNativeReflectConstruct"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _react = _interopRequireWildcard(require("react"));
var _uikit = require("@gravity-ui/uikit");
var _cn = require("../../helpers/cn");
var _Icon = require("../Icon/Icon");
var _some = _interopRequireDefault(require("lodash/some"));
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _callSuper(t, o, e) {
  return o = (0, _getPrototypeOf2.default)(o), (0, _possibleConstructorReturn2.default)(t, (0, _isNativeReflectConstruct2.default)() ? Reflect.construct(o, e || [], (0, _getPrototypeOf2.default)(t).constructor) : o.apply(t, e));
}
var block = (0, _cn.dfCN)('dialog-tab');
var TabField = exports.TabField = /*#__PURE__*/function (_Component) {
  function TabField() {
    (0, _classCallCheck2.default)(this, TabField);
    return _callSuper(this, TabField, arguments);
  }
  (0, _inherits2.default)(TabField, _Component);
  return (0, _createClass2.default)(TabField, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        tabItems = _this$props.tabItems,
        activeTab = _this$props.activeTab,
        setActiveTab = _this$props.setActiveTab,
        onRemoveTab = _this$props.onRemoveTab,
        onCreateTab = _this$props.onCreateTab;
      return /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.TabList, {
        value: activeTab,
        onUpdate: setActiveTab,
        className: block('control', className),
        children: tabItems.map(function (item) {
          return /*#__PURE__*/(0, _jsxRuntime.jsx)(_uikit.Tab, {
            value: item.id,
            children: TabField.wrapTabItem({
              onRemoveTab: onRemoveTab,
              onCreateTab: onCreateTab,
              item: item
            })
          }, item.id);
        })
      });
    }
  }], [{
    key: "getDefaultValue",
    value: function getDefaultValue(tabSpec) {
      return tabSpec.multiple ? [] : {};
    }
  }, {
    key: "isEmpty",
    value: function isEmpty(value, tabSpec) {
      return tabSpec.multiple ? !value.length : !Object.keys(value).length;
    }
  }]);
}(_react.Component);
TabField.isTabControl = true;
TabField.isTabControlVertical = false;
TabField.wrapTabItem = function (props) {
  var _item$title;
  var onRemoveTab = props.onRemoveTab,
    item = props.item,
    wrapperClassName = props.wrapperClassName;
  var hasError = item.error && ('string' === typeof item.error || (0, _some.default)(item.error, function (v) {
    return Boolean(v);
  }));
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: block('wrapper', wrapperClassName),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
      className: block('name'),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        className: block('name-text'),
        children: (_item$title = item.title) !== null && _item$title !== void 0 ? _item$title : item.name
      }), hasError && /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        className: block('warning-icon'),
        title: "Some fields in this tab are not valid",
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.DangerIcon, {})
      })]
    }), item.multiple && item.removable && /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: block('remove-icon'),
      onClick: function onClick(e) {
        e.stopPropagation();
        onRemoveTab === null || onRemoveTab === void 0 || onRemoveTab(item);
      },
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Icon.CloseIcon, {})
    })]
  }, item.id);
};
// #sourceMappingURL=TabField.js.map
// #sourceMappingURL=TabField.js.map