import React from 'react';
import { SegmentedRadioGroupProps } from '@gravity-ui/uikit';
export interface RadioButtonControlProps extends Omit<SegmentedRadioGroupProps, 'onChange' | 'value'> {
    value: SegmentedRadioGroupProps['value'];
    onChange: (value: RadioButtonControlProps['value']) => void;
    options?: Array<{
        value: string;
        label: React.ReactNode;
    }>;
}
export declare function RadioButtonControl({ value, onChange, ...props }: RadioButtonControlProps): React.JSX.Element;
export declare namespace RadioButtonControl {
    var getDefaultValue: () => string;
    var isEmpty: (value: string | null | undefined) => boolean;
}
