import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import React from 'react';
import { DFDialog, registerDialogControl } from '../../../index';
import { jsxs as _jsxs, jsx as _jsx } from "react/jsx-runtime";
function MyControl(props) {
  return /*#__PURE__*/_jsxs("div", {
    children: ["Hello, ", props.username, "!"]
  });
}
MyControl.getDefaultValue = function () {
  return null;
};

// step 1
registerDialogControl('my-control', MyControl);

// step 2

// step 3
function MyDialog(props) {
  return /*#__PURE__*/_jsx(DFDialog, _objectSpread({}, props));
}
function Demo() {
  return /*#__PURE__*/_jsxs("div", {
    style: {
      whiteSpace: 'pre'
    },
    children: ["The library provides limited amount of basic control that you may use out of the box.", /*#__PURE__*/_jsx("br", {}), "But sometimes it is required to add some project-specific controls, in that case", /*#__PURE__*/_jsx("br", {}), "you need to implement required control and then correctly register it.", /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx("br", {}), "It is impossible to modify the declaration of DFDialogField type, but it is possible to", /*#__PURE__*/_jsx("br", {}), "implement your own dialog which will wrap DFDialog and have extended set of allowed controls.", /*#__PURE__*/_jsx("br", {}), "This example demonstrates how to create your own dialog with additional fields.", /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx("br", {}), "To register a custom control you need to complete 3 steps:", /*#__PURE__*/_jsxs("ol", {
      children: [/*#__PURE__*/_jsx("li", {
        children: "Register a custom control with a unique type"
      }), /*#__PURE__*/_jsx("li", {
        children: "Declare DialogField type that extends DFDialogField"
      }), /*#__PURE__*/_jsx("li", {
        children: "Implement your own Dialog which will use DialogField type from step 2"
      })]
    }), "Please see its internals:\xA0", /*#__PURE__*/_jsx("a", {
      href: 'https://github.com/gravity-ui/dialog-fields/blob/main/src/stories/dialog/register/RegisterControls.stories.tsx',
      children: "the code"
    }), /*#__PURE__*/_jsx("br", {}), /*#__PURE__*/_jsx("br", {}), "Also it might be useful to know:", /*#__PURE__*/_jsx("br", {}), "- registerDialogControl accepts only Components which Props extends interface:", /*#__PURE__*/_jsx("code", {
      children: '\n interface ControlProps<V> {' + '\n    value: V;' + '\n    onChange: (value: V, opts?: any) => void;' + '\n    error?: string;' + '\n }\n'
    }), /*#__PURE__*/_jsx("br", {}), "- and static methods/fields of the component should satisfy to:", /*#__PURE__*/_jsx("code", {
      children: '\n interface ControlStaticApi<V> {' + '\n    isEmpty?: (value: V) => boolean;' + '\n    getDefaultValue: () => V;' + '\n    hasErrorRenderer?: boolean;' + '\n    validate?: ValidatorType<V, any>;' + '\n    format?: (value: V, name: string) => any;' + '\n }\n\n'
    }), /*#__PURE__*/_jsx("h3", {
      children: "Usage:"
    }), /*#__PURE__*/_jsx(MyDialog, {
      visible: true,
      modal: false,
      fields: [{
        name: 'username',
        type: 'my-control',
        caption: 'My control',
        extras: {
          username: 'world'
        }
      }],
      onAdd: function onAdd() {
        return Promise.resolve();
      }
    })]
  });
}
export default {
  title: 'Tutorials/Custom control registration',
  component: Demo
};
var Template = function Template() {
  return /*#__PURE__*/_jsx(Demo, {});
};
export var Primary = Template.bind({});
Primary.args = {};
// #sourceMappingURL=RegisterControls.stories.js.map