import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React, { Component } from 'react';
import { TabList, Tab } from '@gravity-ui/uikit';
import { dfCN } from '../../helpers/cn';
import { DangerIcon, CloseIcon } from '../Icon/Icon';
import some_ from 'lodash/some';
import './TabField.css';
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
var block = dfCN('dialog-tab');
export var TabField = /*#__PURE__*/function (_Component) {
  function TabField() {
    _classCallCheck(this, TabField);
    return _callSuper(this, TabField, arguments);
  }
  _inherits(TabField, _Component);
  return _createClass(TabField, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        tabItems = _this$props.tabItems,
        activeTab = _this$props.activeTab,
        setActiveTab = _this$props.setActiveTab,
        onRemoveTab = _this$props.onRemoveTab,
        onCreateTab = _this$props.onCreateTab;
      return /*#__PURE__*/_jsx(TabList, {
        value: activeTab,
        onUpdate: setActiveTab,
        className: block('control', className),
        children: tabItems.map(function (item) {
          return /*#__PURE__*/_jsx(Tab, {
            value: item.id,
            children: TabField.wrapTabItem({
              onRemoveTab: onRemoveTab,
              onCreateTab: onCreateTab,
              item: item
            })
          }, item.id);
        })
      });
    }
  }], [{
    key: "getDefaultValue",
    value: function getDefaultValue(tabSpec) {
      return tabSpec.multiple ? [] : {};
    }
  }, {
    key: "isEmpty",
    value: function isEmpty(value, tabSpec) {
      return tabSpec.multiple ? !value.length : !Object.keys(value).length;
    }
  }]);
}(Component);
TabField.isTabControl = true;
TabField.isTabControlVertical = false;
TabField.wrapTabItem = function (props) {
  var _item$title;
  var onRemoveTab = props.onRemoveTab,
    item = props.item,
    wrapperClassName = props.wrapperClassName;
  var hasError = item.error && ('string' === typeof item.error || some_(item.error, function (v) {
    return Boolean(v);
  }));
  return /*#__PURE__*/_jsxs("div", {
    className: block('wrapper', wrapperClassName),
    children: [/*#__PURE__*/_jsxs("span", {
      className: block('name'),
      children: [/*#__PURE__*/_jsx("span", {
        className: block('name-text'),
        children: (_item$title = item.title) !== null && _item$title !== void 0 ? _item$title : item.name
      }), hasError && /*#__PURE__*/_jsx("span", {
        className: block('warning-icon'),
        title: "Some fields in this tab are not valid",
        children: /*#__PURE__*/_jsx(DangerIcon, {})
      })]
    }), item.multiple && item.removable && /*#__PURE__*/_jsx("span", {
      className: block('remove-icon'),
      onClick: function onClick(e) {
        e.stopPropagation();
        onRemoveTab === null || onRemoveTab === void 0 || onRemoveTab(item);
      },
      children: /*#__PURE__*/_jsx(CloseIcon, {})
    })]
  }, item.id);
};
// #sourceMappingURL=TabField.js.map