import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
var _excluded = ["className", "activeTab", "size", "sortable", "tabItems", "onOrderChanged"];
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React from 'react';
import { dfCN } from '../../helpers/cn';
import findIndex_ from 'lodash/findIndex';
import { TabField } from './TabField';
import { List } from '@gravity-ui/uikit';
import './TabFieldVertical.css';
import { jsx as _jsx } from "react/jsx-runtime";
var block = dfCN('tab-field-vertical');
var ITEM_HEIGHT = {
  s: 28,
  m: 36,
  l: 48
};
export var TabFieldVertical = /*#__PURE__*/function (_React$Component) {
  function TabFieldVertical() {
    var _this;
    _classCallCheck(this, TabFieldVertical);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _callSuper(this, TabFieldVertical, [].concat(args));
    _this.onItemClick = function (item) {
      var setActiveTab = _this.props.setActiveTab;
      setActiveTab(item.id);
    };
    _this.renderItem = function (item) {
      var _this$props = _this.props,
        onRemoveTab = _this$props.onRemoveTab,
        onCreateTab = _this$props.onCreateTab,
        wrapTo = _this$props.wrapTo;
      var node = TabField.wrapTabItem({
        onRemoveTab: onRemoveTab,
        onCreateTab: onCreateTab,
        item: item,
        wrapperClassName: block('wrapper')
      });
      return wrapTo ? wrapTo(node, item) : node;
    };
    return _this;
  }
  _inherits(TabFieldVertical, _React$Component);
  return _createClass(TabFieldVertical, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        activeTab = _this$props2.activeTab,
        size = _this$props2.size,
        sortable = _this$props2.sortable,
        tabItems = _this$props2.tabItems,
        onOrderChanged = _this$props2.onOrderChanged,
        rest = _objectWithoutProperties(_this$props2, _excluded);
      var selected = findIndex_(tabItems, function (_ref) {
        var id = _ref.id;
        return id === activeTab;
      });
      return /*#__PURE__*/_jsx("div", {
        className: block({
          size: size
        }, className),
        children: /*#__PURE__*/_jsx(List, _objectSpread({
          className: block('list'),
          itemHeight: ITEM_HEIGHT[size || TabFieldVertical.defaultProps.size],
          size: size,
          items: tabItems,
          renderItem: this.renderItem,
          onItemClick: this.onItemClick,
          selectedItemIndex: selected,
          filterable: false,
          onSortEnd: onOrderChanged,
          sortable: sortable
        }, rest))
      });
    }
  }]);
}(React.Component);
TabFieldVertical.defaultProps = {
  size: 's'
};
TabFieldVertical.isTabControl = true;
TabFieldVertical.isTabControlVertical = true;
TabFieldVertical.getDefaultValue = TabField.getDefaultValue;
TabFieldVertical.isEmpty = TabField.isEmpty;
// #sourceMappingURL=TabFieldVertical.js.map