import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _isNativeReflectConstruct from "@babel/runtime/helpers/isNativeReflectConstruct";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
import React from 'react';
import { Button } from '@gravity-ui/uikit';
import { getDisplayName } from './utils';
import { jsx as _jsx } from "react/jsx-runtime";
export default function withCollapsible(Component) {
  var _WithCollapsible;
  var ResultComponent = (_WithCollapsible = /*#__PURE__*/function (_React$Component) {
    function WithCollapsible(props) {
      var _this;
      _classCallCheck(this, WithCollapsible);
      _this = _callSuper(this, WithCollapsible, [props]);
      _this.state = {
        collapsed: true
      };
      _this.handleToggle = function () {
        return _this.setState(function (prevState) {
          return {
            collapsed: !prevState.collapsed
          };
        });
      };
      _this.renderToggler = function () {
        var _this$props = _this.props,
          items = _this$props.items,
          visibleCount = _this$props.visibleCount;
        var collapsed = _this.state.collapsed;
        var hasToggler = items.length > visibleCount;
        var resCount = items.length - visibleCount;
        return hasToggler && /*#__PURE__*/_jsx(Button, {
          size: "s",
          view: "flat",
          onClick: _this.handleToggle,
          children: collapsed ? "Show more (".concat(resCount, ")") : 'Show less'
        });
      };
      _this.state = {
        collapsed: !props.initialExpanded
      };
      if (props.renderToggler) {
        console.warn('"renderToggler" property will be overriden');
      }
      return _this;
    }
    _inherits(WithCollapsible, _React$Component);
    return _createClass(WithCollapsible, [{
      key: "render",
      value: function render() {
        return /*#__PURE__*/_jsx(Component, _objectSpread(_objectSpread({}, this.props), {}, {
          items: this.getItems(),
          renderToggler: this.renderToggler
        }));
      }
    }, {
      key: "getItems",
      value: function getItems() {
        var visibleCount = this.getVisibleItemsCount();
        var items = this.props.items;
        return visibleCount < items.length ? items.slice(0, visibleCount) : items;
      }
    }, {
      key: "getVisibleItemsCount",
      value: function getVisibleItemsCount() {
        var _this$props2 = this.props,
          items = _this$props2.items,
          visibleCount = _this$props2.visibleCount;
        var collapsed = this.state.collapsed;
        return collapsed && items.length > visibleCount ? visibleCount : items.length;
      }
    }]);
  }(React.Component), _WithCollapsible.displayName = "WithCollapsible(".concat(getDisplayName(Component), ")"), _WithCollapsible);
  return ResultComponent;
}
// #sourceMappingURL=withCollapsible.js.map