import React from 'react';
import { TabField, TabFieldProps, TabItem } from './TabField';
import { ListProps } from '@gravity-ui/uikit';
import './TabFieldVertical.scss';
declare const ITEM_HEIGHT: {
    s: number;
    m: number;
    l: number;
};
export interface TabFieldVerticalProps extends TabFieldProps {
    size?: keyof typeof ITEM_HEIGHT;
    sortable?: boolean;
    onOrderChanged?: ListProps<any>['onSortEnd'];
    wrapTo?: (node: React.ReactNode, item: TabItem) => React.ReactNode;
    virtualized?: boolean;
}
export declare class TabFieldVertical extends React.Component<TabFieldVerticalProps> {
    static defaultProps: {
        size: "s" | "l" | "m";
    };
    static isTabControl: true;
    static isTabControlVertical: boolean;
    static getDefaultValue: typeof TabField.getDefaultValue;
    static isEmpty: typeof TabField.isEmpty;
    onItemClick: (item: TabItem) => void;
    renderItem: (item: TabItem) => string | number | boolean | Iterable<React.ReactNode> | React.JSX.Element | null | undefined;
    render(): React.JSX.Element;
}
export {};
